---
title: Handling media support issues in web content
slug: Web/Media/Formats/Support_issues
tags:
  - Audio
  - Guide
  - HTMLAudioElement
  - HTMLMediaElement
  - HTMLVideoElement
  - Intermediate
  - Media
  - Sources
  - Video
  - WebRTC
  - fallbacks
  - sound
---
<p>{{draft}}</p>

<p>One of the realities of working with audio and video presentation and manipulation on the web is that there are a number of media formats available, of varying degrees of popularity and with a variety of capabilities. The availability of choices is good for the user, in that they can choose the format that suits their needs best. There is a drawback, however: because there are so many to choose from, with so many different kinds of licenses and design principles involved, each web browser developer is left to its own devices when deciding which media file types and codecs to support.</p>

<p>This places a small, but reasonably easily overcome, burden on the web developer: to properly handle the situation when the user's browser can't handle a particular type of media. <span class="seoSummary">This guide covers techniques you can use to develop web content that meets your media needs while providing the most broadly compatible experience possible. </span>Topics we will examine fallbacks, baseline media formats, and error handling practices that will let your content work in as many situations as possible.</p>

<h2 id="Using_poster_frames">Using poster frames</h2>

<p>A <strong>poster frame</strong> is a still image that's representative of the content of a video. This may be the first frame of video; however, in many cases, the first frame is blank, or contains nothing but the logo of a business, or some other image that doesn't give the reader any context for the video's contents.</p>

<p>A good poster frame is one which is either a representative of the video's contents, or is an image which isn't even from the video itself but contains imagery and/or text which gives the reader a useful idea of the video's contents. In the case of an action movie, for example, the poster frame might be an iconic exemplar image from one of the film's best-known scenes.</p>

<p>A similar concept can be applied to still images; if an image you wish to present is very large and may take time to download (especially for slower devices or connections), you can offer a lower-resolution or alternate version that will be displayed until the full-quality version is available to be displayed.</p>

<p>We'll look at both of these scenarios and how to implement them.</p>

<h3 id="Poster_frames_for_video">Poster frames for video</h3>

<h3 id="Progressive_images">Progressive images</h3>

<p>Images—whether embedded using {{HTMLElement("img")}} or {{HTMLElement("picture")}}—don't support a concept similar to poster frames. However, there are ways to present an image in low quality while it's still loading. This requires creating your images using <strong>progressive</strong> formats, such as progressive {{Glossary("JPEG")}} or interlaced {{Glossary("PNG")}}.</p>

<p>Once your image has been converted to progressive form, you can use it as usual.</p>

<pre class="brush: html">&lt;img src="/images/stafff-photo-huge-progressive.jpg"
     alt="Staff Photo, taken in January of 1972"&gt;</pre>

<p>When using a progressive image, the data is stored in such a way that the browser is able to render a low-quality representation of the image as soon as possible, then update the image as it loads—or after it's finished loading—to present it in full quality.</p>

<div class="notecard note">
<p><strong>Note:</strong> Progressive (or interlaced) images are inherently slightly larger than the non-progressive versions of the same images. Whether the interlacing will benefit your users is up to you to determine.</p>
</div>

<h2 id="Specifying_multiple_sources">Specifying multiple sources</h2>

<h2 id="Checking_compatibility_in_JavaScript">Checking compatibility in JavaScript</h2>

<p>{{domxref("HTMLMediaElement.canPlayType")}} and {{domxref("MediaSource.isTypeSupported")}}...</p>

<h2 id="Detecting_playback_errors">Detecting playback errors</h2>

<h2 id="Adapting_presentation_with_CSS">Adapting presentation with CSS</h2>

<h2 id="Memory_management">Memory management</h2>

<h2 id="See_also">See also</h2>
